//+------------------------------------------------------------------+
//|                                   Nondisclosure007 Framework.mq4 |
//|                               Copyright  2007, Nondisclosure007 |
//|                                               http://no.link.yet |
//|                   Altered for the EA "switcher" at forex-tsd.com |
//|    http://www.forex-tsd.com/expert-analysis/4794-ea-switcher.html|
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Nondisclosure007"
#property link      "http://no.link.yet"
#include <stdlib.mqh>
#include <stderror.mqh>

extern string label1           = "=== Money and Trade Management =";
extern bool   MoneyManagement  = false; // Change to false to shutdown money management controls.
extern double TradeSizePercent = 3;     // Change to whatever percent of equity you wish to risk.
extern double Lots             = 0.01;  // standard lot size when MoneyManagement = false.
extern double MaxLots          = 50;    // Max amount of Lots allowed.
extern int    MaxPositions     = 1;     // Max number of positions PER SYMBOL!!
//+---------------------------------------------------+
//|Profit controls                                    |
//+---------------------------------------------------+
extern int    Slippage         = 3;    // Possible fix for not getting filled or closed  
extern double Risk             = 5;    // Risk Percentage, PER POSITION, when using Money Managemet
extern double stopLoss         = 0;    // Set in points your stoploss.  If set to 0, will use Parabolic Sar for Stoploss.
extern double takeProfit       = 0;    // Set in points your takeprofit.  If set to 0, 'letting it ride'.
   
double lotMM;
int MagicNumber;
string setup = "";
int totalTries = 5; 
int retryDelay = 1000;
bool Debug = false;

int init()
{
 	MagicNumber = 5000 + Symbol2Val(Symbol())*100 + TimeFrame_Const2Val(Period()); 
   setup="EA Switcher" + Symbol() + "_" + TimeFrame_Val2String(TimeFrame_Const2Val(Period()));

   return(0);
}
int deinit()
{

   return(0);
}
int start()
{
  HandleOpenPositions();
  if (CheckOpenPositions()<MaxPositions && newbar()==Period()) 
   {
    lotMM = GetLots();
      if(OpenSignal()==1)  
      {
         OpenBuyOrder();
         return(0);
      }
      else if(OpenSignal()==2) 
      {
         OpenSellOrder();
         return(0);
      }
   }

   return(0);
}

int newbar()
{
   double g;
   int m,s,k;
   m=Time[0]+Period()*60-TimeCurrent();
   g=m/60.0;
   s=m%60;
   m=(m-m%60)/60;
   return(m);
}

//+------------------------------------------------------------------+
//| OpenSignal()                                                     |
//| Returns 1 == Open a Buy order.                                   |
//| Returns 2 == Open a Sell order.                                  |
//| Returns 0 == Don't open any order.                               |
//+------------------------------------------------------------------+
int OpenSignal()
{
   if (TrendMarket()==1 && ChoppyMarket()!=1) 
   {
      if (OpenTrendOrder()==1)
      {
         return(1);
      }
   } 
   if (TrendMarket()==2 && ChoppyMarket()!=2) 
   {
      if (OpenTrendOrder()==2)
      {
         return(2);
      }
   } 
   if (TrendMarket()!=1 && ChoppyMarket()==1) 
   {
      if (OpenChoppyOrder()==1)
      {
         return(1);
      }
   } 
   if (TrendMarket()!=2 && ChoppyMarket()==2) 
   {
      if (OpenChoppyOrder()==2)
      {
         return(2);
      }
   } 
   return(0);
}

//+------------------------------------------------------------------+
//| TrendMarket()                                                    |
//| Checks the market for a "Trending situation"                     |
//+------------------------------------------------------------------+
int TrendMarket()
{
   //insert code to determine if it is a trending market.
   //return 1 if it's trending long, 2 if it's trending short.
   
   return(0);
}

//+------------------------------------------------------------------+
//| ChoppyMarket()                                                   |
//| Checks the market for a "Choppy market situation"                |
//+------------------------------------------------------------------+
int ChoppyMarket()
{
   //insert code to determine if it is a trending market.
   //return 1 if it's choppy long, 2 if it's choppy short.

   return(0);
}

//+------------------------------------------------------------------+
//| OpenTrendOrder()                                                 | 
//| Determines whether or not to open a postition in the trending    |
//|         market.                                                  |
//|------------------------------------------------------------------+
int OpenTrendOrder()
{
   //indies to determine to open order.
   //return 1 for a long, 2 for a short.
   
   return(0);
}

//+------------------------------------------------------------------+
//| OpenChoppyOrder                                                  |
//| Determines whether or not to open a position in the choppy       |
//|         market.                                                  |
//+------------------------------------------------------------------+
int OpenChoppyOrder()
{
   //indies to determine to open order.
   //return 1 for a long, 2 for a short.
   
   return(0);
}

int ExitSignal(int cnt)
{
   // Code to determine when to exit the position
   // Return 1 to close a long, 2 to close a short.
   
   return(0);
}

//+------------------------------------------------------------------+
//| OpenBuyOrder                                                     |
//| If Stop Loss or TakeProfit are used the values are calculated    |
//| for each trade                                                   |
//+------------------------------------------------------------------+
void OpenBuyOrder()
{
   int ticket;
   int cnt, err, digits;
   double myStopLoss = 0, myTakeProfit = 0, myPrice = 0;
   double sarStop=iSAR(NULL,0,0.02,0.2,1);
   
   myPrice = MarketInfo(Symbol(), MODE_ASK);
   if (stopLoss==0)
   {
	  if (sarStop < iLow(NULL,0,1)) {stopLoss=sarStop;}
	}
	else
	{
	  myStopLoss=(stopLoss*Point)-Ask;
	}
   digits = MarketInfo(Symbol(), MODE_DIGITS);
	if (digits > 0) 
	{
		myPrice = NormalizeDouble(myPrice, digits);
	   myStopLoss = NormalizeDouble(stopLoss, digits);
		myTakeProfit = NormalizeDouble(takeProfit, digits); 
	}
      OrderSend(Symbol(),OP_BUY,lotMM,myPrice,Slippage,myStopLoss,myTakeProfit,setup,MagicNumber,0,LimeGreen); //myStopLoss,myTakeProfit
	   if (ticket > 0)
	   {
		    if (OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) 
		    {
		       if (Debug) Print("BUY order opened : ", OrderOpenPrice());
		    }
	   }
	   else
	   {
		    err = GetLastError();
          Print("Error opening BUY order : (" + err + ") " + ErrorDescription(err));
      }
   return(0);   
}
//+------------------------------------------------------------------+
//| OpenSellOrder                                                    |
//| If Stop Loss or TakeProfit are used the values are calculated    |
//| for each trade                                                   |
//+------------------------------------------------------------------+
void OpenSellOrder()
{
   int ticket;
   int cnt, err, digits;
   double myStopLoss = 0, myTakeProfit = 0, myPrice = 0;
   double sarStop=iSAR(NULL,0,0.02,0.2,1);
   
   myPrice = MarketInfo(Symbol(), MODE_BID);
   if (stopLoss==0)
   {
	  if (sarStop < iLow(NULL,0,1)) {stopLoss=sarStop;}
	}
	else
	{
	  myStopLoss=(stopLoss*Point)-Bid;
	}
	digits = MarketInfo(Symbol(), MODE_DIGITS);
	if (digits > 0) 
	{
	   myPrice = NormalizeDouble(myPrice, digits);
	   myStopLoss = NormalizeDouble(myStopLoss, digits);
	   myTakeProfit = NormalizeDouble(myTakeProfit, digits); 
	}
      ticket=OrderSend(Symbol(),OP_SELL,lotMM,myPrice,Slippage,myStopLoss,myTakeProfit,setup,MagicNumber,0,Red); //myStopLoss,myTakeProfit
   	if (ticket > 0)
	   {
		   if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
			{
			  if (Debug) Print("SELL order opened : ", OrderOpenPrice());
			}
	   }
	   else
	  {
			err = GetLastError();
         Print("Error opening SELL order : (" + err + ") " + ErrorDescription(err));
      }
     
	return(0);
}
//+------------------------------------------------------------------+
//| Check Open Position Controls                                     |
//+------------------------------------------------------------------+
int CheckOpenPositions()
{
   int cnt, total, NumPositions;
   int NumBuyTrades, NumSellTrades;   // Number of buy and sell trades in this symbol
   
   NumBuyTrades = 0;
   NumSellTrades = 0;
   total=OrdersTotal();
   for(cnt=OrdersTotal()-1;cnt>=0;cnt--)
     {
      OrderSelect (cnt, SELECT_BY_POS, MODE_TRADES);
      if ( OrderSymbol() != Symbol()) continue;
      if ( OrderMagicNumber() != MagicNumber)  continue;
      if(OrderType() == OP_BUY )  NumBuyTrades++;
      if(OrderType() == OP_SELL ) NumSellTrades++;
     }
     NumPositions = NumBuyTrades + NumSellTrades;
     return (NumPositions);
  }
//+------------------------------------------------------------------+
//| Modify Open Position Controls                                    |
//|  Try to modify position 3 times                                  |
//+------------------------------------------------------------------+
bool ModifyOrder(int nOrderType, int ord_ticket,double op, double price,double tp, color mColor = CLR_NONE)
{
    int cnt, err;
    double myStop;
    
    myStop = ValidStopLoss (nOrderType, price);
    cnt=0;
    while (cnt < totalTries)
    {
       if (OrderModify(ord_ticket,op,myStop,tp,0,mColor))
       {
         return(true);
       }
       else
       {
          err=GetLastError();
          if (err > 1) Print(cnt," Error modifying order : (", ord_ticket , ") " + ErrorDescription(err), " err ",err);
          if (err>0) cnt++;
          Sleep(retryDelay);
       }
    }
    return(false);
}

// 	Adjust stop loss so that it is legal.
double ValidStopLoss(int cmd, double sl)
{
   
   double sarStop=iSAR(NULL,0,0.02,0.2,1);
   double mySL, myPrice;
   
   mySL = sl;
   switch(cmd)
   {
   case OP_BUY:
      if (sarStop < iLow(NULL,0,1)) mySL=sarStop;
      break;
   case OP_SELL:
      if (sarStop > iHigh(NULL,0,1)) mySL=sarStop;
      break;
   }
   return(NormalizeDouble(mySL,MarketInfo(Symbol(), MODE_DIGITS)));
}

int HandleTrailingStop(int type, int ticket, double op, double os, double tp)
{
    double pt, TS=0, myAsk, myBid;
    double bos,bop,opa,osa, mySL;
    double sarStop=iSAR(NULL,0,0.02,0.2,1);
    
    switch(type)
    {
       case OP_BUY:
       {
   		 myBid = MarketInfo(Symbol(),MODE_BID);
          if (sarStop < iLow(NULL,0,1)) mySL=sarStop;
          else mySL=os;
          ModifyOrder(type,ticket,op,mySL,tp, Aqua);
          break;
       }
       case  OP_SELL:
       {
		    myAsk = MarketInfo(Symbol(),MODE_ASK);
          if (sarStop > iHigh(NULL,0,1)) mySL=sarStop;
          else mySL=os;
          ModifyOrder(type,ticket,op,mySL,tp, Aqua);
          break;
       }
    }
    return(0);
}

//+------------------------------------------------------------------+
//| Handle Open Positions                                            |
//| Check if any open positions need to be closed or modified        |
//+------------------------------------------------------------------+
int HandleOpenPositions()
{
   int cnt;
   
   for(cnt=OrdersTotal()-1;cnt>=0;cnt--)
   {
      OrderSelect (cnt, SELECT_BY_POS, MODE_TRADES);
      if ( OrderSymbol() != Symbol()) continue;
      if ( OrderMagicNumber() != MagicNumber)  continue;
      
      if(OrderType() == OP_BUY)
      {
         if ( ExitSignal(cnt)==1)
          {
              OrderClose(OrderTicket(),OrderLots(),Bid, Slippage, Violet);
          }
          else
          {
               HandleTrailingStop(OP_BUY,OrderTicket(),OrderOpenPrice(),OrderStopLoss(),OrderTakeProfit());
          }
      }

      if(OrderType() == OP_SELL)
      {
          if (ExitSignal(cnt)==2)
          {
             OrderClose(OrderTicket(),OrderLots(),Ask, Slippage, Violet);
          }
          else
          {
               HandleTrailingStop(OP_SELL,OrderTicket(),OrderOpenPrice(),OrderStopLoss(),OrderTakeProfit());
          }
       }
   }return(0);
}

     
//+------------------------------------------------------------------+
//| Get optimal number of lots for this trade                        |
//+------------------------------------------------------------------+
double GetLots()
{
   double lot;
   
   if(MoneyManagement)
   {
      lot=NormalizeDouble((AccountFreeMargin()*(Risk/100))*AccountLeverage()/MarketInfo(Symbol(),MODE_LOTSIZE),2);
   }
   else
   {
     lot = Lots;
   }
   
   if (lot > MaxLots) lot = MaxLots;
   return(lot);
}

//+------------------------------------------------------------------+
//| Time frame interval appropriation  function                      |
//+------------------------------------------------------------------+
int TimeFrame_Const2Val(int Constant) 
{
   switch(Constant) 
   {
      case 1:  
         return(1);
      case 5:  
         return(2);
      case 15:
         return(3);
      case 30:
         return(4);
      case 60:
         return(5);
      case 240:
         return(6);
      case 1440:
         return(7);
      case 10080:
         return(8);
      case 43200:
         return(9);
   }
}
//+------------------------------------------------------------------+
//| Time frame string appropriation  function                               |
//+------------------------------------------------------------------+
string TimeFrame_Val2String(int Value) 
{
   switch(Value) 
   {
      case 1:  
         return("PERIOD_M1");
      case 2:  
         return("PERIOD_M5");
      case 3:
         return("PERIOD_M15");
      case 4:
         return("PERIOD_M30");
      case 5:
         return("PERIOD_H1");
      case 6:
         return("PERIOD_H4");
      case 7:
         return("PERIOD_D1");
      case 8:
         return("PERIOD_W1");
      case 9:
         return("PERIOD_MN1");
   	default: 
   		return("undefined " + Value);
   }
}
int Symbol2Val(string symbol) 
{
   string mySymbol = StringSubstr(symbol,0,6);
	if(mySymbol=="AUDCAD" || mySymbol=="AUDCADm") return(1);
	if(mySymbol=="AUDJPY" || mySymbol=="AUDJPYm") return(2);
	if(mySymbol=="AUDNZD" || mySymbol=="AUDNZDm") return(3);
	if(mySymbol=="AUDUSD" || mySymbol=="AUDUSDm") return(4);
	if(mySymbol=="CHFJPY" || mySymbol=="CHFJPYm") return(5);
	if(mySymbol=="EURAUD" || mySymbol=="EURAUDm") return(6);
	if(mySymbol=="EURCAD" || mySymbol=="EURCADm") return(7);
	if(mySymbol=="EURCHF" || mySymbol=="EURCHFm") return(8);
	if(mySymbol=="EURGBP" || mySymbol=="EURGBPm") return(9);
	if(mySymbol=="EURJPY" || mySymbol=="EURJPYm") return(10);
	if(mySymbol=="EURUSD" || mySymbol=="EURUSDm") return(11);
	if(mySymbol=="GBPCHF" || mySymbol=="GBPCHFm") return(12);
	if(mySymbol=="GBPJPY" || mySymbol=="GBPJPYm") return(13);
	if(mySymbol=="GBPUSD" || mySymbol=="GBPUSDm") return(14);
	if(mySymbol=="NZDUSD" || mySymbol=="NZDUSDm") return(15);
	if(mySymbol=="USDCAD" || mySymbol=="USDCADm") return(16);
	if(mySymbol=="USDCHF" || mySymbol=="USDCHFm") return(17);
	if(mySymbol=="USDJPY" || mySymbol=="USDJPYm") return(18);
	return(19);
}

